<template>
  <button type="button" class="btn" :class="classes" @click="onClick" :style="style">{{ label }}</button>
</template>

<script lang="ts">
import Vue from 'vue'
import {Prop, Component} from 'vue-property-decorator'
import {Sizes} from './types'

@Component({})
export default class MyButton extends Vue {
    @Prop({required: true})
    label!: string
    
    @Prop({default: false})
    primary!: boolean

    @Prop({default: null})
    size!: Sizes | null

    @Prop({default: null})
    backgroundColor!: string

    get classes() {
      return {
        'btn-primary': this.primary,
        'btn-secondary': !this.primary,
        [`btn-${this.size}`]: this.size,
      };
    }

    get style() {
      return {
        backgroundColor: this.backgroundColor,
      };
    }

    onClick() {
      this.$emit('onClick');
    }
}
</script>
